# TODO: POPULATE THE CONFIGS, OXFORDS IS THE MOS TUP TO DATE.
# +--------------------------------------------------------------------------+
# |                                                                          |
# |                                Derwent                                   |
# |                                                                          |
# +--------------------------------------------------------------------------+

derwent:
  name: "Derwent"
  manufacturer: "Turntide"
  model: "Prototype"
  sample:
    letter: "A"
    number: 1

  
  parameters:

    crash_value: 0x5C5C
    
    bridge:
      enable: 4
      disable: 0

    continuous:
      current: nan
    peak:
      current: nan
      
    
    limits:
      
      max:
        power: nan
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      
      min:
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      dc_link:
        current:
          discharge: 600.0
          charge: -600.0

        voltage_limit: nan

      speed:
        forward: 10000.0
        reverse: -10000.0

      torque:
        drive: 300.0
        brake: -300.0
  

      switch:
        voltage_threshold: nan
        resistance: nan
        diode_drip_voltage: nan
        diode_drip_resistance: nan
        breakdown_voltage: nan
        current_limit: nan
        energy_on: nan
        energy_off: nan
        frequency: nan

      diode:
        reverse_voltage: nan
        forward_current: nan
        reverse_energy: nan

    # DERWENT: PARAMETERS: RESET ================================================================
    reset:
      torque:
        qm:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
        fusa:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
      speed:
        transmission: 0.0
        limits:
          forward: 0.0
          reverse: 0.0
      dc_link:
        limits:
          voltage:
            max: 420.0
            min: 0.0
          current:
            discharge: 1.0
            charge: 1.0
      status:
        contactor: 5
      crash:
        active_discharge: 0
      bridge:
        enable: 0

  # DERWENT: CONFIG ================================================================
  config:
    tables:
      voltage:
        breakpoints: [150, 180, 220, 240, 260, 280, 300, 320, 340]
      speed:
        breakpoints: [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500.0]
      torque:
        peak: [
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [285.583418848043,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [226.795429163605,260.182246909201,285.668297835937,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [177.949324826979,211.056714723455,248.305675502718,262.937300376296,275.147254952391,283.230963035568,286.919087900264,286.919087900264,286.919087900264,],
                [144.891028035928,173.978737566603,209.405976875078,225.618808222456,240.082879946902,253.06087810775,264.517631349955,274.335064855334,281.290364913358,],
                [121.803745350631,147.041575986411,179.356860646952,194.370807996921,208.359019691151,221.768320414942,234.495943437085,246.21100985348,256.646007820339,],
                [104.957061890792,127.274225338822,155.885831905037,169.476201844729,182.845274893292,195.485504412679,207.755264047202,219.464318293347,230.398713742742,],
                [91.9218231078475,111.704669998831,137.357269095916,150.058774482126,162.044593954854,173.942647670478,185.43009401419,196.508012927248,207.205047233369,],
                [81.7462770552869,99.6122066558159,122.813871777867,134.140705875621,145.349440494131,156.384973722967,166.960335656497,177.421939409628,187.541229172617,],
                [73.5923408504398,89.7601872811817,110.997302476172,121.270027376933,131.487251652779,141.620308519637,151.648379123474,161.111122593735,170.916137877905,],
                [66.8738395913367,81.5802008351773,101.08002802521,110.579343462692,120.144951680198,129.409350434029,138.779296537114,147.544523344774,156.494990238726,],
                [61.3306437699175,74.7893080010025,92.6910246639165,101.607847894947,110.463342847128,119.077163712693,127.693458508102,136.125830040349,144.340017940942,],
                [56.5576182533882,69.0155011018235,85.5907455103901,93.8012497471727,102.020210621593,110.103406782343,118.182391227428,126.206497332946,133.974110393119,],
              ]
    max:
      torque: "max_of_peak_torque"
      speed: "max_of_speed_breakpoints"
      voltage: "max_of_voltage_breakpoints"

    dc_link:
      current:
        discharge: 400.0
        charge: -400.0

  # DERWENT: CAN ================================================================
  can:  
    database:
      dbc: "dbc_path"
      eds: "eds_path"

    bitrate: 1000000
    period: 0.1

    # DERWENT: CAN: SIGNALS ======================================================
    signals:
      bridge:
        enable: "COMMAND"
        state: "INVERTER_STAT"
        status: "INVERTER_STAT"

      status:
        alert_id:  "ALERT_ID"
        block_id: "BLOCK_ID"
        contactor: "CONTACTOR_STATE"
        fault: "FAULT_STAT"
        kl_30: "KL30_STATE"
        status: "STATUS"
        placeholder: "PLACEHOLDER"

      speed:
        feedback: "MOTOR_VELOCITY"
        transmission: "TRANS_SPEED" 
        limits:
          forward: "FWD_SPD_LIM"
          reverse: "REV_SPD_LIM"

      torque:
        qm: 
          demand: "T_DEMAND_QM"
        
          limits:
            drive: "T_DRV_LIM_QM"
            brake: "T_BRK_LIM_QM"
          
          feedback:
            actual: "EST_TORQUE" 
            estimated: ""
            max_drive_available: "MAX_AVAIL_DRV_T"
            max_brake_available: "MAX_AVAIL_BRK_T"
        
        fusa: 
          demand: "T_DEMAND_FUSA"
        
          limits:
            drive: "T_DRV_LIM_FUSA"
            brake: "T_BRK_LIM_FUSA"
          
          feedback:
            actual: "" 
            estimated: ""

      dc_link:
        feedback:
          voltage: "DCLINK_V"
          current: "DCLINK_I"

        limits:
          current:
              charge: "I_RECH_LIM"
              discharge: "I_DIS_LIM"
          
          voltage:
              max: "V_MAX"
              min: "V_MIN"
      
      temperature:
        feedback:
          inverter:
            heatsink: ""
            switch: ""
            inverter: "INVERTER_TEMPERATURE"

          motor:
            rotor: ""
            cavity: ""
            stator: ""
            motor: "MOTOR_TEMPERATURE"

      motor_control:

        feedback:
          ud: "D_AXIS_U"
          uq: "Q_AXIS_U"
          id: "D_AXIS_I"
          iq: "Q_AXIS_I"
          mod_index: "MOD_INDEX"
          ke: ""
          switching_frequency: "SW_FREQ"

        reference:
          id: ""
          iq: ""


      crash:
        active_discharge: "ACTIVE_DISCHARGE"

    # DERWENT: CAN: MESSAGES ============================================================   
    messages:
      bridge:
        enable: "VC_SpdCmd"
        state: "MC_Sts_2"
        status: "MC_Sts_2"

      status:
        alert_id:  "MC_V2_Debug_3"
        block_id: "MC_V2_Debug_3"
        contactor: "PDU_Status_4"
        fault: "MC_Sts_2"
        kl_30: "MC_Sts_2"
        status: "MC_V2_Debug_3"
        placeholder: "MC_V2_Debug_3"

      speed:
        feedback: "MC_Vel"
        transmission: "VC_TransSpd" 
        limits:
          forward: "VC_SpdCmd"
          reverse: "VC_SpdCmd"

      torque:
        qm: 
          demand: "VC_Trq_QM"
        
          limits:
            drive: "VC_Trq_QM"
            brake: "VC_Trq_QM"
          
          feedback:
            actual: "MC_Trq" 
            estimated: ""
            max_drive_available: "MC_Trq"
            max_brake_available: "MC_Trq"
        
        fusa: 
          demand: "VC_Trq_FuSa"
        
          limits:
            drive: "VC_Trq_FuSa"
            brake: "VC_Trq_FuSa"
          
          feedback:
            actual: ""
            estimated: ""

      dc_link:
        feedback:
          voltage: "MC_Sts"
          current: "MC_Sts"

        limits:
          current:
              charge: "VC_Bat"
              discharge: "VC_Bat"
          
          voltage:
              max: "VC_Bat"
              min: "VC_Bat"
      
      temperature:
        feedback:
          inverter:
            heatsink: ""
            switch: ""
            inverter: "MC_Sts_2"

          motor:
            rotor: ""
            cavity: ""
            stator: ""
            motor: "MC_Sts"

      motor_control:

        feedback:
          ud: "MC_V2_Debug_1"
          uq: "MC_V2_Debug_1"
          id: "MC_V2_Debug_1"
          iq: "MC_V2_Debug_1"
          mod_index: "MC_V2_Debug_1"
          ke: ""
          switching_frequency: ""

        reference:
          id: ""
          iq: ""


      crash:
        active_discharge: "VC_CrashInd"

  # DERWENT: PROPERTIES =================================================================
  properties:
    idq:
      ids:
        id: "0x40570029"
        iq: "0x4057002A"
        mode: "0x40570027"
        axis: "0x40570028"

# +--------------------------------------------------------------------------+
# |                                                                          |
# |                                Hawkshead                                 |
# |                                                                          |
# +--------------------------------------------------------------------------+

hawkshead:
  name: "Hawkshead"
  manufacturer: "Turntide"
  model: "Prototype"
  sample:
    letter: "A"
    number: 1

  
  parameters:

    crash_value: 0x5C5C
    
    bridge:
      enable: 4
      disable: 0

    continuous:
      current: nan
    peak:
      current: nan
      
    
    limits:
      
      max:
        power: nan
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      
      min:
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      dc_link:
        current:
          discharge: 600.0
          charge: -600.0

        voltage_limit: nan

      speed:
        forward: 10000.0
        reverse: -10000.0

      torque:
        drive: 300.0
        brake: -300.0
  

      switch:
        voltage_threshold: nan
        resistance: nan
        diode_drip_voltage: nan
        diode_drip_resistance: nan
        breakdown_voltage: nan
        current_limit: nan
        energy_on: nan
        energy_off: nan
        frequency: nan

      diode:
        reverse_voltage: nan
        forward_current: nan
        reverse_energy: nan
    
    # HAWKSHEAD: PARAMETERS: RESET ================================================================
    reset:
      torque:
        qm:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
        fusa:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
      speed:
        transmission: 0.0
        limits:
          forward: 0.0
          reverse: 0.0
      dc_link:
        limits:
          voltage:
            max: 420.0
            min: 0.0
          current:
            discharge: 1.0
            charge: 1.0
      status:
        contactor: 5
      crash:
        active_discharge: 0
      bridge:
        enable: 0

  # HAWKSHEAD: CONFIG ================================================================
  config:
    tables:
      voltage:
        breakpoints: [150, 180, 220, 240, 260, 280, 300, 320, 340]
      speed:
        breakpoints: [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500.0]
      torque:
        peak: [
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [285.583418848043,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [226.795429163605,260.182246909201,285.668297835937,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [177.949324826979,211.056714723455,248.305675502718,262.937300376296,275.147254952391,283.230963035568,286.919087900264,286.919087900264,286.919087900264,],
                [144.891028035928,173.978737566603,209.405976875078,225.618808222456,240.082879946902,253.06087810775,264.517631349955,274.335064855334,281.290364913358,],
                [121.803745350631,147.041575986411,179.356860646952,194.370807996921,208.359019691151,221.768320414942,234.495943437085,246.21100985348,256.646007820339,],
                [104.957061890792,127.274225338822,155.885831905037,169.476201844729,182.845274893292,195.485504412679,207.755264047202,219.464318293347,230.398713742742,],
                [91.9218231078475,111.704669998831,137.357269095916,150.058774482126,162.044593954854,173.942647670478,185.43009401419,196.508012927248,207.205047233369,],
                [81.7462770552869,99.6122066558159,122.813871777867,134.140705875621,145.349440494131,156.384973722967,166.960335656497,177.421939409628,187.541229172617,],
                [73.5923408504398,89.7601872811817,110.997302476172,121.270027376933,131.487251652779,141.620308519637,151.648379123474,161.111122593735,170.916137877905,],
                [66.8738395913367,81.5802008351773,101.08002802521,110.579343462692,120.144951680198,129.409350434029,138.779296537114,147.544523344774,156.494990238726,],
                [61.3306437699175,74.7893080010025,92.6910246639165,101.607847894947,110.463342847128,119.077163712693,127.693458508102,136.125830040349,144.340017940942,],
                [56.5576182533882,69.0155011018235,85.5907455103901,93.8012497471727,102.020210621593,110.103406782343,118.182391227428,126.206497332946,133.974110393119,],
              ]
    max:
      torque: "max_of_peak_torque"
      speed: "max_of_speed_breakpoints"
      voltage: "max_of_voltage_breakpoints"

    dc_link:
      current:
        discharge: 400.0
        charge: -400.0

  # HAWKSHEAD: CAN ================================================================
  can:  
    database:
      dbc: "dbc_path"
      eds: "eds_path"

    bitrate: 1000000
    period: 0.1
    # HAWKSHEAD: CAN: SIGNALS ======================================================
    signals:
      bridge:
        enable: "COMMAND"
        state: "INVERTER_STAT"
        status: "INVERTER_STAT"

      status:
        alert_id:  "ALERT_ID"
        block_id: "BLOCK_ID"
        contactor: "CONTACTOR_STATE"
        fault: "FAULT_STAT"
        kl_30: "KL30_STATE"
        status: "STATUS"
        placeholder: "PLACEHOLDER"

      speed:
        feedback: "MOTOR_VELOCITY"
        transmission: "TRANS_SPEED" 
        limits:
          forward: "FWD_SPD_LIM"
          reverse: "REV_SPD_LIM"

      torque:
        qm: 
          demand: "T_DEMAND_QM"
        
          limits:
            drive: "T_DRV_LIM_QM"
            brake: "T_BRK_LIM_QM"
          
          feedback:
            actual: "EST_TORQUE" 
            estimated: ""
            max_drive_available: "MAX_AVAIL_DRV_T"
            max_brake_available: "MAX_AVAIL_BRK_T"
        
        fusa: 
          demand: "T_DEMAND_FUSA"
        
          limits:
            drive: "T_DRV_LIM_FUSA"
            brake: "T_BRK_LIM_FUSA"
          
          feedback:
            actual: "" 
            estimated: ""

      dc_link:
        feedback:
          voltage: "DCLINK_V"
          current: "DCLINK_I"

        limits:
          current:
              charge: "I_RECH_LIM"
              discharge: "I_DIS_LIM"
          
          voltage:
              max: "V_MAX"
              min: "V_MIN"
      
      temperature:
        feedback:
          inverter:
            heatsink: ""
            switch: ""
            inverter: "INVERTER_TEMPERATURE"

          motor:
            rotor: ""
            cavity: ""
            stator: ""
            motor: "MOTOR_TEMPERATURE"

      motor_control:

        feedback:
          ud: "D_AXIS_U"
          uq: "Q_AXIS_U"
          id: "D_AXIS_I"
          iq: "Q_AXIS_I"
          mod_index: "MOD_INDEX"
          ke: ""
          switching_frequency: "SW_FREQ"

        reference:
          id: ""
          iq: ""


      crash:
        active_discharge: "ACTIVE_DISCHARGE"

    # HAWKSHEAD: CAN: MESSAGES ============================================================   
    messages:
      bridge:
        enable: "VC_SpdCmd"
        state: "MC_Sts_2"
        status: "MC_Sts_2"

      status:
        alert_id:  "MC_V2_Debug_3"
        block_id: "MC_V2_Debug_3"
        contactor: "PDU_Status_4"
        fault: "MC_Sts_2"
        kl_30: "MC_Sts_2"
        status: "MC_V2_Debug_3"
        placeholder: "MC_V2_Debug_3"

      speed:
        feedback: "MC_Vel"
        transmission: "VC_TransSpd" 
        limits:
          forward: "VC_SpdCmd"
          reverse: "VC_SpdCmd"

      torque:
        qm: 
          demand: "VC_Trq_QM"
        
          limits:
            drive: "VC_Trq_QM"
            brake: "VC_Trq_QM"
          
          feedback:
            actual: "MC_Trq" 
            estimated: ""
            max_drive_available: "MC_Trq"
            max_brake_available: "MC_Trq"
        
        fusa: 
          demand: "VC_Trq_FuSa"
        
          limits:
            drive: "VC_Trq_FuSa"
            brake: "VC_Trq_FuSa"
          
          feedback:
            actual: ""
            estimated: ""

      dc_link:
        feedback:
          voltage: "MC_Sts"
          current: "MC_Sts"

        limits:
          current:
              charge: "VC_Bat"
              discharge: "VC_Bat"
          
          voltage:
              max: "VC_Bat"
              min: "VC_Bat"
      
      temperature:
        feedback:
          inverter:
            heatsink: ""
            switch: ""
            inverter: "MC_Sts_2"

          motor:
            rotor: ""
            cavity: ""
            stator: ""
            motor: "MC_Sts"

      motor_control:

        feedback:
          ud: "MC_V2_Debug_1"
          uq: "MC_V2_Debug_1"
          id: "MC_V2_Debug_1"
          iq: "MC_V2_Debug_1"
          mod_index: "MC_V2_Debug_1"
          ke: ""
          switching_frequency: ""
        
        reference:
          id: ""
          iq: ""


      crash:
        active_discharge: "VC_CrashInd"

  # HAWKSHEAD: PROPERTIES ======================================================
  properties:
    idq:
      ids:
        id: "0x40570029"
        iq: "0x4057002A"
        mode: "0x40570027"
        axis: "0x40570028"

# +--------------------------------------------------------------------------+
# |                                                                          |
# |                                Blencathra                                |
# |                                                                          |
# +--------------------------------------------------------------------------+

belcathra:
  name: "Gen 5 Size 9"
  manufacturer: "Turntide"
  model: "Blencathra"
  sample:
    letter: "D"
    number: 1

  
  parameters:

    continuous:
      current: nan
    peak:
      current: nan
      
    
    limits:
      
      max:
        power: nan
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      
      min:
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      dc_link:
        current:
          discharge: 500.0
          charge: -500.0

      switch:
        voltage_threshold: nan
        resistance: nan
        diode_drip_voltage: nan
        diode_drip_resistance: nan
        breakdown_voltage: nan
        current_limit: nan
        energy_on: nan
        energy_off: nan
        frequency: nan

      diode:
        reverse_voltage: nan
        forward_current: nan
        reverse_energy: nan

    # BLENCATHRA : PARAMETERS: RESET ================================================================
    reset:
      torque:
        qm:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
        fusa:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
      speed:
        transmission: 0.0
        limits:
          forward: 0.0
          reverse: 0.0
      dc_link:
        limits:
          voltage:
            max: 420.0
            min: 0.0
          current:
            discharge: 1.0
            charge: 1.0
      status:
        contactor: 5
      crash:
        active_discharge: 0
      bridge:
        enable: 0
        
  # BLENCATHRA: CONFIG ================================================================
  config:
    tables:
      voltage:
        breakpoints: [150, 180, 220, 240, 260, 280, 300, 320, 340]
      speed:
        breakpoints: [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500.0]
      torque:
        peak: [
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [285.583418848043,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [226.795429163605,260.182246909201,285.668297835937,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [177.949324826979,211.056714723455,248.305675502718,262.937300376296,275.147254952391,283.230963035568,286.919087900264,286.919087900264,286.919087900264,],
                [144.891028035928,173.978737566603,209.405976875078,225.618808222456,240.082879946902,253.06087810775,264.517631349955,274.335064855334,281.290364913358,],
                [121.803745350631,147.041575986411,179.356860646952,194.370807996921,208.359019691151,221.768320414942,234.495943437085,246.21100985348,256.646007820339,],
                [104.957061890792,127.274225338822,155.885831905037,169.476201844729,182.845274893292,195.485504412679,207.755264047202,219.464318293347,230.398713742742,],
                [91.9218231078475,111.704669998831,137.357269095916,150.058774482126,162.044593954854,173.942647670478,185.43009401419,196.508012927248,207.205047233369,],
                [81.7462770552869,99.6122066558159,122.813871777867,134.140705875621,145.349440494131,156.384973722967,166.960335656497,177.421939409628,187.541229172617,],
                [73.5923408504398,89.7601872811817,110.997302476172,121.270027376933,131.487251652779,141.620308519637,151.648379123474,161.111122593735,170.916137877905,],
                [66.8738395913367,81.5802008351773,101.08002802521,110.579343462692,120.144951680198,129.409350434029,138.779296537114,147.544523344774,156.494990238726,],
                [61.3306437699175,74.7893080010025,92.6910246639165,101.607847894947,110.463342847128,119.077163712693,127.693458508102,136.125830040349,144.340017940942,],
                [56.5576182533882,69.0155011018235,85.5907455103901,93.8012497471727,102.020210621593,110.103406782343,118.182391227428,126.206497332946,133.974110393119,],
              ]

    max:
      torque: "max_of_peak_torque"
      speed: "max_of_speed_breakpoints"
      voltage: "max_of_voltage_breakpoints"

    dc_link:
      current:
        discharge: 400.0
        charge: -400.0

  # BLENCATHRA: CAN ================================================================
  can:
    database:
      dbc: "dbc_path"
      eds: "eds_path"

    bitrate: 1000000
    period: 0.1
    # BLENCATHRA: CAN: SIGNALS ======================================================
    ids:
      speed:
        feedback: "can_id"
        limits:
          forward: "can_id"
          reverse: "can_id"

      torque:
        limits:
          drive: "can_id"
          brake: "can_id"
        feedback:
          actual: "can_id"
          demand: "can_id"
          estimated: "can_id"

      current:
        limits:
          charge: "can_id"
          discharge: "can_id"
      
      voltage:
        limits:
          max: "can_id"
          min: "can_id"
      
      temperature:
        inverter:
          heatsink: "can_id"
          switch: "can_id"
        motor:
          rotor: "can_id"
          cavity: "can_id"
          stator: "can_id"

      stationary_frame:
        feedback:
          ud: "can_id"
          uq: "can_id"
          id: "can_id"
          iq: "can_id"
        reference:
          id: "can_id"
          iq: "can_id"

  # BLENCATHRA: PROPERTIES ===================================================
  properties:
    idq:
      ids:
        id: "0x40570029"
        iq: "0x4057002A"
        mode: "0x40570027"
        axis: "0x40570028"

# +--------------------------------------------------------------------------+
# |                                                                          |
# |                                 Oxford                                   |
# |                                                                          |
# +--------------------------------------------------------------------------+

oxford:
  name: "Oxford"
  manufacturer: "Turntide"
  model: "Prototype"
  sample:
    letter: "A"
    number: 1

  parameters:

    crash_value: 0x5C5C

    bridge:
      enable: 4
      disable: 0

    continuous:
      current: nan
    peak:
      current: nan
      
    limits:
      max:
        power: nan
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      min:
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      dc_link:
        current:
          discharge: 600.0
          charge: -600.0

        voltage_limit: nan

      speed:
        forward: 8500.0
        reverse: -8500.0

      torque:
        drive: 270.0
        brake: -270.0
  

      switch:
        voltage_threshold: nan
        resistance: nan
        diode_drip_voltage: nan
        diode_drip_resistance: nan
        breakdown_voltage: nan
        current_limit: nan
        energy_on: nan
        energy_off: nan
        frequency: nan

      diode:
        reverse_voltage: nan
        forward_current: nan
        reverse_energy: nan

  # OXFORD: CONFIG ================================================================
  config:
    tables:
      voltage:
        breakpoints: [150, 180, 220, 240, 260, 280, 300, 320, 340]
      speed:
        breakpoints: [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500.0]
      torque:
        peak: [
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [285.583418848043,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [226.795429163605,260.182246909201,285.668297835937,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [177.949324826979,211.056714723455,248.305675502718,262.937300376296,275.147254952391,283.230963035568,286.919087900264,286.919087900264,286.919087900264,],
                [144.891028035928,173.978737566603,209.405976875078,225.618808222456,240.082879946902,253.06087810775,264.517631349955,274.335064855334,281.290364913358,],
                [121.803745350631,147.041575986411,179.356860646952,194.370807996921,208.359019691151,221.768320414942,234.495943437085,246.21100985348,256.646007820339,],
                [104.957061890792,127.274225338822,155.885831905037,169.476201844729,182.845274893292,195.485504412679,207.755264047202,219.464318293347,230.398713742742,],
                [91.9218231078475,111.704669998831,137.357269095916,150.058774482126,162.044593954854,173.942647670478,185.43009401419,196.508012927248,207.205047233369,],
                [81.7462770552869,99.6122066558159,122.813871777867,134.140705875621,145.349440494131,156.384973722967,166.960335656497,177.421939409628,187.541229172617,],
                [73.5923408504398,89.7601872811817,110.997302476172,121.270027376933,131.487251652779,141.620308519637,151.648379123474,161.111122593735,170.916137877905,],
                [66.8738395913367,81.5802008351773,101.08002802521,110.579343462692,120.144951680198,129.409350434029,138.779296537114,147.544523344774,156.494990238726,],
                [61.3306437699175,74.7893080010025,92.6910246639165,101.607847894947,110.463342847128,119.077163712693,127.693458508102,136.125830040349,144.340017940942,],
                [56.5576182533882,69.0155011018235,85.5907455103901,93.8012497471727,102.020210621593,110.103406782343,118.182391227428,126.206497332946,133.974110393119,],
              ]
    max:
      torque: "max_of_peak_torque"
      speed: "max_of_speed_breakpoints"
      voltage: "max_of_voltage_breakpoints"

    dc_link:
      current:
        discharge: 400.0
        charge: -400.0

  # OXFORD: CAN ================================================================
  can:  
    database: "program\\src\\equipment\\controllers\\databases\\McLaren_P16_AR3.5_MCU_ECU_Communication_Extract_v6.0.0.arxml"
    interface: "ixxat"
    channel : 0
    bitrate: 500000
    period: 0.1
    # OXFORD: PARAMETERS: INITIAL VALUES ================================================================
    intial_values:
      torque:
        qm:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
        fusa:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
      speed:
        transmission: 0.0
        limits:
          forward: 0.0
          reverse: 0.0
      dc_link:
        limits:
          voltage:
            max: 420.0
            min: 0.0
          current:
            discharge: 1.0
            charge: 1.0
      status:
        contactor: 5
      crash:
        active_discharge: 0
      bridge:
        enable: 0
    # OXFORD: CAN: SIGNALS ======================================================
    signals:
      bridge:
        enable: "NMCU1Command"
        state: "NMCU1Status"
        status: "NMCU1Status"

      status:
        alert_id:  "MCU_Flt_AlertID"
        block_id: "MCU_Flt_BlkID"
        contactor: ""
        fault: "NMCU1Fault"
        kl_30: "BMC_Sts_5_SysStatus_KL30Stat"
        status: "NMCU1Status"
        placeholder: ""
        hvil: "NMCUHVILState"

      speed:
        feedback: "neMotorROutboard"
        transmission: "nHSU_MCU1_TransSpeed" 
        limits:
          forward: "neMotorRSpeedControlMaxLimFinal"
          reverse: "neMotorRSpeedControlMinLimFinal"

      torque:
        qm: 
          demand: "MeMotorRDemandedFinal"
        
          limits:
            drive: "MeMotorRTorqueControlMaxLimFinal"
            brake: "MeMotorRTorqueControlMinLimFinal"
          
          feedback:
            actual: "MeMotorREstimated" 
            estimated: ""
            max_drive_available: ""
            max_brake_available: ""
        
        fusa: 
          demand: ""
        
          limits:
            drive: ""
            brake: ""
          
          feedback:
            actual: "" 
            estimated: ""

      power:
        motor:
          mechanical: "MeMotorREstimated"

      dc_link:
        feedback:
          voltage: "VMCU1DCLink"
          current: "IMCU1DCLink"

        limits:
          current:
              charge: "IMCU1DCLinkMaxLim"
              discharge: "IMCU1DCLinkMinLim"
          
          voltage:
              max: "VMCU1DCLinkMaxLim"
              min: "VMCU1DCLinkMinLim"
      
      temperature:
        feedback:
          inverter:
            switch: "TMCU1IGBT"
            capacitor: "TMCU1CAP"
            ac_link: "TMCU1ACLink"
            dc_link: "TMCU1DCLink"

          motor:
            core: "TeMotorRStatorCore"
            winding: "TeMotorRStatorWinding"
            cavity: "TeMotorRCavity2"
            
      motor_control:
        
        feedback:
          ud: "VeMotorRUd"
          uq: "VeMotorRUq"
          us: "VeMotorRPhase"
          id: "IeMotorRId"
          iq: "IeMotorRIq"
          is: "IeMotorRPhase"
          mod_index: "rMCU1ModIdx"
          ke: ""
          switching_frequency: "fMCU1Switching"
        
        reference:
          id: ""
          iq: ""
        
        tables:
          index:
            ke: "NMC_Sts_7_Ke_Index"
            speed: "NMC_Sts_7_Speed_Index"
            torque: "NMC_Sts_7_Torque_Index"
            voltage: "NMC_Sts_7_Voltage_Index"

      crash:
        active_discharge: "NMCU1ActShrtCrct"

    # OXFORD: CAN: MESSAGES ============================================================
    messages:
      bridge:
        enable: "HSU_MCU1_Cmd_Grp"
        state: "MCU1_Status1"
        status: "MCU1_Sts1_Grp"

      status:
        alert_id:  ""
        block_id: ""
        contactor: ""
        fault: "NMCU1Fault"
        kl_30: "MCU1_Sts5_Grp"
        status: "MCU1_Sts1_Grp"
        placeholder: ""
        HVIL: "MCU1_Sts5_Grp"

      speed:
        feedback: "MCU1_Status1"
        transmission: "HSU_MCU1_TransSpeed_Grp" 
        limits:
          forward: "HSU_MCU1_Command"
          reverse: "HSU_MCU1_Command"

      torque:
        qm: 
          demand: "HSU_MCU1_Cmd_PDU"
        
          limits:
            drive: "HSU_MCU1_Command"
            brake: "HSU_MCU1_Command"
          
          feedback:
            actual: "MCU1_Status1" 
            estimated: "MCU1_Status1"
            max_drive_available: ""
            max_brake_available: ""
        
        fusa: 
          demand: ""
        
          limits:
            drive: ""
            brake: ""
          
          feedback:
            actual: "" 
            estimated: ""

      dc_link:
        feedback:
          voltage: "MCU1_Status2"
          current: "MCU1_Status2"

        limits:
          current:
              charge: ""
              discharge: ""
          
          voltage:
              max: ""
              min: ""
      
      temperature:
        feedback:
          inverter:
            switch: "MCU1_Status3"
            capacitor: "MCU1_Status3"
            ac_link: "MCU1_Status3"
            dc_link: "MCU1_Status3"

          motor:
            core: "MCU1_Status3"
            winding: "MCU1_Status3"
            cavity: "MCU1_Status3"


      motor_control:
        
        feedback:
          ud: "MCU1_Status4"
          uq: "MCU1_Status4"
          id: "MCU1_Status4"
          iq: "MCU1_Status4"
          mod_index: "MCU1_Status4"
          ke: ""
          switching_frequency: "MCU1_Status4"
        
        reference:
          id: ""
          iq: ""
        
        tables:
          index:
            ke: "MCU1_Status7"
            speed: "MCU1_Status7"
            torque: "MCU1_Status7"
            voltage: "MCU1_Status7"

      crash:
        active_discharge: "HSU_MCU1_Cmd_Grp"

  # OXFORD: PROPERTIES ========================================================
  properties:
    idq:
      ids:
        id: "0x40570029"
        iq: "0x4057002A"
        mode: "0x40570027"
        axis: "0x40570028"

# +--------------------------------------------------------------------------+
# |                                                                          |
# |                                 Bowfell                                  |
# |                                                                          |
# +--------------------------------------------------------------------------+

bowfell:
  name: "Bowfell"
  manufacturer: "Turntide"
  model: "Prototype"
  sample:
    letter: "A"
    number: 1

  
  parameters:

    crash_value: 0x5C5C
    
    bridge:
      enable: 4
      disable: 0

    continuous:
      current: nan
    peak:
      current: nan
      
    limits:
      
      max:
        power: nan
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      min:
        voltage: nan
        current: nan

        coolant:
          rate: nan
          temperature: nan

      dc_link:
        current:
          discharge: 600.0
          charge: -600.0

        voltage_limit: nan

      speed:
        forward: 10000.0
        reverse: -10000.0

      torque:
        drive: 300.0
        brake: -300.0
  

      switch:
        voltage_threshold: nan
        resistance: nan
        diode_drip_voltage: nan
        diode_drip_resistance: nan
        breakdown_voltage: nan
        current_limit: nan
        energy_on: nan
        energy_off: nan
        frequency: nan

      diode:
        reverse_voltage: nan
        forward_current: nan
        reverse_energy: nan

    # BOWFELL: PARAMETERS: RESET ================================================================
    reset:
      torque:
        qm:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
        fusa:
          demand: 0.0
          limits:
            drive: 0.0
            brake: 0.0
      speed:
        transmission: 0.0
        limits:
          forward: 0.0
          reverse: 0.0
      dc_link:
        limits:
          voltage:
            max: 420.0
            min: 0.0
          current:
            discharge: 1.0
            charge: 1.0
      status:
        contactor: 5
      crash:
        active_discharge: 0
      bridge:
        enable: 0

  # BOWFELL: CONFIG ================================================================
  config:
    tables:
      voltage:
        breakpoints: [150, 180, 220, 240, 260, 280, 300, 320, 340]
      speed:
        breakpoints: [0, 884.6153846, 1769.230769, 2653.846154, 3538.461538, 4423.076923, 5307.692308, 6192.307692, 7076.923077, 7961.538462, 8846.153846, 9730.769231, 10615.38462, 11500.0]
      torque:
        peak: [
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [285.583418848043,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [226.795429163605,260.182246909201,285.668297835937,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,286.919087900264,],
                [177.949324826979,211.056714723455,248.305675502718,262.937300376296,275.147254952391,283.230963035568,286.919087900264,286.919087900264,286.919087900264,],
                [144.891028035928,173.978737566603,209.405976875078,225.618808222456,240.082879946902,253.06087810775,264.517631349955,274.335064855334,281.290364913358,],
                [121.803745350631,147.041575986411,179.356860646952,194.370807996921,208.359019691151,221.768320414942,234.495943437085,246.21100985348,256.646007820339,],
                [104.957061890792,127.274225338822,155.885831905037,169.476201844729,182.845274893292,195.485504412679,207.755264047202,219.464318293347,230.398713742742,],
                [91.9218231078475,111.704669998831,137.357269095916,150.058774482126,162.044593954854,173.942647670478,185.43009401419,196.508012927248,207.205047233369,],
                [81.7462770552869,99.6122066558159,122.813871777867,134.140705875621,145.349440494131,156.384973722967,166.960335656497,177.421939409628,187.541229172617,],
                [73.5923408504398,89.7601872811817,110.997302476172,121.270027376933,131.487251652779,141.620308519637,151.648379123474,161.111122593735,170.916137877905,],
                [66.8738395913367,81.5802008351773,101.08002802521,110.579343462692,120.144951680198,129.409350434029,138.779296537114,147.544523344774,156.494990238726,],
                [61.3306437699175,74.7893080010025,92.6910246639165,101.607847894947,110.463342847128,119.077163712693,127.693458508102,136.125830040349,144.340017940942,],
                [56.5576182533882,69.0155011018235,85.5907455103901,93.8012497471727,102.020210621593,110.103406782343,118.182391227428,126.206497332946,133.974110393119,],
              ]
    max:
      torque: "max_of_peak_torque"
      speed: "max_of_speed_breakpoints"
      voltage: "max_of_voltage_breakpoints"

    dc_link:
      current:
        discharge: 400.0
        charge: -400.0

  # BOWFELL: CAN ================================================================
  can:  
    database:
      dbc: "dbc_path"
      eds: "eds_path"

    bitrate: 1000000
    period: 0.1
    # BOWFELL: CAN: SIGNALS ======================================================
    signals:
      bridge:
        enable: "VC_SpdCmd_Cmd_InvEnable"
        state: "MC_Sts_2_SysStatus_InvStat"
        status: "MC_Sts_2_SysStatus_InvStat"

      status:
        alert_id:  "MC_Debug_3_AlertID"
        block_id: "MC_Debug_3_BlockID"
        contactor: "CONTACTOR_STATE"
        fault: "FAULT_STAT"
        kl_30: "MC_Sts_2_SysStatus_KL30Stat"
        status: "MC_Debug_3_Status"
        placeholder: "MC_Debug_3_Status"

      speed:
        feedback: "MC_Vel_MotVel"
        transmission: "VC_TransSpeed" 
        limits:
          forward: "VC_SpdCmd_FrwdSpdLim"
          reverse: "VC_SpdCmd_RvrsSpdLim"

      torque:
        qm: 
          demand: "VC_Trq_TrqTrgt"
        
          limits:
            drive: "VC_Trq_DrvTrqLmt_FuSa"
            brake: "VC_Trq_BrkTrqLmt_FuSa"
          
          feedback:
            actual: "MC_Trq_EstTrq" 
            estimated: ""
            max_drive_available: "MC_Trq_MaxAvaDrvTrq"
            max_brake_available: "MC_Trq_MaxAvaBrkTrq"
        
        fusa: 
          demand: "VC_Trq_TrqTrgt_Fusa"
        
          limits:
            drive: "VC_Trq_DrvTrqLmt_FuSa"
            brake: "VC_Trq_BrkTrqLmt_FuSa"
          
          feedback:
            actual: ""
            estimated: ""

      dc_link:
        feedback:
          voltage: "MC_Sts_U_DClink"
          current: "MC_Sts_I_DClink"

        limits:
          current:
              charge: "VC_Bat_I_DCLinkReLim"
              discharge: "VC_Bat_I_DCLinkDisLim"
          
          voltage:
              max: "VC_Bat_U_DCLinkHighLim"
              min: "VC_Bat_U_DCLinkLowLim"
      
      temperature:
        feedback:
          inverter:
            heatsink: ""
            switch: ""
            inverter: "MC_Sts_2_InvTempAct"

          motor:
            rotor: ""
            cavity: ""
            stator: ""
            motor: "MC_Sts_MotTempAct"

      motor_control:
      
        feedback:
          ud: "MC_Debug_Ud"
          uq: "MC_Debug_Uq"
          id: "MC_Debug_id"
          iq: "MC_Debug_Iq"
          mod_index: "MC_Debug_Mod_idx"
          ke: ""
          switching_frequency: ""

        reference:
          id: "MC_Debug_Id_Ref"
          iq: "MC_Debug_Iq_Ref"


      crash:
        active_discharge: "VC_CrashInd_CrashEvent"
    
    # BOWFELL: CAN: MESSAGES ============================================================
    messages:
      bridge:
        enable: "VC_SpdCmd"
        state: "MC_Sts_2"
        status: "MC_Sts_2"

      status:
        alert_id:  "MC_V2_Debug_3"
        block_id: "MC_V2_Debug_3"
        contactor: "PDU_Status_4"
        fault: "MC_Sts_2"
        kl_30: "MC_Sts_2"
        status: "MC_V2_Debug_3"
        placeholder: "MC_V2_Debug_3"

      speed:
        feedback: "MC_Vel"
        transmission: "VC_TransSpd" 
        limits:
          forward: "VC_SpdCmd"
          reverse: "VC_SpdCmd"

      torque:
        qm: 
          demand: "VC_Trq"
        
          limits:
            drive: "VC_Trq"
            brake: "VC_Trq"
          
          feedback:
            actual: "MC_Trq" 
            estimated: ""
            max_drive_available: "MC_Trq"
            max_brake_available: "MC_Trq"
        
        fusa: 
          demand: "VC_Trq_FuSa"
        
          limits:
            drive: "VC_Trq_FuSa"
            brake: "VC_Trq_FuSa"
          
          feedback:
            actual: ""
            estimated: ""

      dc_link:
        feedback:
          voltage: "MC_Sts"
          current: "MC_Sts"

        limits:
          current:
              charge: "VC_Bat"
              discharge: "VC_Bat"
          
          voltage:
              max: "VC_Bat"
              min: "VC_Bat"
      
      temperature:
        feedback:
          inverter:
            heatsink: ""
            switch: ""
            inverter: "MC_Sts_2"

          motor:
            rotor: ""
            cavity: ""
            stator: ""
            motor: "MC_Sts"

      motor_control:

        feedback:
          ud: "MC_V2_Debug_1"
          uq: "MC_V2_Debug_1"
          id: "MC_V2_Debug_1"
          iq: "MC_V2_Debug_1"
          mod_index: "MC_V2_Debug_1"
          ke: ""
          switching_frequency: ""
        
        reference:
          id: "MC_V2_Debug_2"
          iq: "MC_V2_Debug_2"

      crash:
        active_discharge: "VC_CrashInd"

  # BOWFELL: PROPERTIES =================================================================
  properties:
    idq:
      ids:
        id: "0x40570029"
        iq: "0x4057002A"
        mode: "0x40570027"
        axis: "0x40570028"